Attribute VB_Name = "modDataLogFile"
Option Explicit
Public hLogFile As Long
Public fDoScanDataFile As Boolean
Public fScanDataFileOpened As Boolean
Public Const SCANFILE_CREATE = 1
Public Const SCANFILE_CLOSE = 3
Public szLogFileName As String
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public dblScanStartTime As Double
Public dblScanEndTime As Double

'8-12-04 Public LTime As Double
Public LTime As Variant

Public Function LogScan(ByVal bFileStat As Byte) As Boolean
    szLogFileName = Month(Date) & "-" & Day(Date) & "-" & Year(Date) _
        & "_" & Hour(Time) & "." & Minute(Time) & "." & Second(Time) & ".txt"

    If bFileStat = SCANFILE_CREATE Then GoTo DO_CREATE
    If bFileStat = SCANFILE_CLOSE Then GoTo DO_CLOSE

DO_CREATE:
    If fScanDataFileOpened = True Then
        LogScan = True
        Exit Function
    End If
    
    hLogFile = FreeFile(3)
    On Error GoTo FILE_ERROR
    Open szLogFileName For Output As #hLogFile
    fScanDataFileOpened = True
    'Print #hLogFile, "Date created: " & Date$ & "  " & Time$
    
    Dim str As String
    str = "Time / s" & vbTab
    
    Dim bIndexSub As Byte
    
    If fIsEMFapp Then
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
                str = str & "1 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
                str = str & "2 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
                str = str & "3 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
                str = str & "4 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
                str = str & "5 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
                str = str & "6 - " & bIndexSub + 1 & "   " & vbTab
            End If
        Next bIndexSub
        
        '9-27-13c ##############
        If frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal" Then
            str = str & "7 - " & "0" + 1 & "   " & vbTab
            str = str & "8 - " & "0" + 1 & "   " & vbTab
        End If
        '#######################
        
        
    Else
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
                str = str & "0 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
                str = str & "1 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
                str = str & "2 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
                str = str & "3 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
                str = str & "4 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        For bIndexSub = 0 To 15
            If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
                str = str & "5 - " & bIndexSub & "   " & vbTab
            End If
        Next bIndexSub
        '9-27-13c ##############
        If frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal" Then
                str = str & "6 - " & 0 & "   " & vbTab
                str = str & "7 - " & 0 & "   "
        End If
        '#######################
    End If
    
    Print #hLogFile, str
    
    GoTo DO_RETURN

DO_CLOSE:


'    Dim dblAppliedRate As Double: dblAppliedRate = M_201.rate / M_201.numChannels
'    Dim dblAppliedInterval As Double: dblAppliedInterval = 1# / dblAppliedRate
'    Dim dblSystemInterval As Double: dblSystemInterval = 1# / M_201.rate
    
    Dim dblAppliedInterval As Double: dblAppliedInterval = 1# / M_201.rate
    Dim dblSystemInterval As Double: dblSystemInterval = M_201.scanInterval
    
    If fScanDataFileOpened = True Then
        Print #hLogFile, ""
        
        Print #hLogFile, "Hz Noise Filter: " & vbTab & ((10 ^ M_201.filter) * 4)
        Print #hLogFile, "Averaging / subcycle: " & vbTab & M_201.average
        
        '==================
        Dim iRet As Integer
        Dim minTime As Double
        Dim maxTime As Double
        Dim scanInterval_SAVE As Double
        scanInterval_SAVE = M_201.scanInterval
        iRet = CheckScanTime(maxTime, minTime)
        M_201.scanInterval = scanInterval_SAVE
        '=====================================
        
        Print #hLogFile, "Minimal System Interval: " & vbTab & Format$(minTime, "##.000")
        Print #hLogFile, "Applied Interval: " & vbTab & Format$(M_201.scanInterval, "##.000")
        
        'If scanCnt = 0 Then scanCnt = 1

        '10-7-05 Print #hLogFile, "Subcycles averaged: " & vbTab & scanCnt
        
        Print #hLogFile, "Started: " & vbTab & Format(dblScanStartTime, "m/d/yy") & ", ";
        Print #hLogFile, Format(dblScanStartTime, "h:mm:ss a/p")
        Print #hLogFile, "Finished: " & vbTab & Format(dblScanEndTime, "m/d/yy") & ", ";
        Print #hLogFile, Format(dblScanEndTime, "h:mm:ss a/p")
        
        '10-7-05 Print #hLogFile, "Experiment Description: " & vbTab & strExperimentName
    End If

    Close #hLogFile
    fScanDataFileOpened = False
    GoTo DO_RETURN

DO_RETURN:
    'fRetVal = True
    LogScan = True
    GoTo EXIT1

FILE_ERROR:
    fDoScanDataFile = False
    On Error GoTo 0
    'fRetVal = False
    LogScan = False
EXIT1:
End Function

Public Function WriteLogFileSubChanOnly(ByVal bMainChan As Byte) As Boolean
    If fScanDataFileOpened = False Then
        Dim fRetVal As Boolean
        Dim bFileStat As Byte
        bFileStat = SCANFILE_CREATE
        fRetVal = LogScan(bFileStat)
        If fRetVal = False Then
            Exit Function
        End If
    End If

    Dim bSubChanIndex As Byte
    '8-12-04 Dim nowTimer As Double
    Dim nowTimer
    nowTimer = Timer
    
    '9-26-13 Print #hLogFile, Format$((scanCnt - 1) * M_201.scanInterval, "0000000.0") & vbTab;
    
    '9-26-13c
    Print #hLogFile, Format$((scanCnt) * M_201.scanInterval, "0000000.0") & vbTab;
    
    Dim bIndexSub As Byte
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
            If dVoltage(0, bIndexSub) < 0 Then
                Print #hLogFile, Format$(str(Abs(dVoltage(0, bIndexSub))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dVoltage(0, bIndexSub))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
'9-25-13    For bIndexSub = 0 To 15
'9-25-13        If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
'9-25-13            If dVoltage(1, bIndexSub) < 0 Then
'9-25-13                Print #hLogFile, Format$(str(Abs(dVoltage(1, bIndexSub))), "-#.000000  ") & vbTab;
'9-25-13            Else
'9-25-13                Print #hLogFile, Format$(str(Abs(dVoltage(1, bIndexSub))), " #.000000  ") & vbTab;
'9-25-13            End If
'9-25-13        End If
'9-25-13    Next bIndexSub
    
    '9-25-13 ##############
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
            '11-21-13
            If (frmChanSelect.chkChan1Subs(0).Value = vbChecked) _
                And (frmChanSelect.chkChan1Subs(1).Value = vbUnchecked) And (bIndexSub = 0) Then
                Dim dblDegrees As Double
                Dim dVoltage_LOCAL As Double
                dVoltage_LOCAL = dVoltage(1, bIndexSub)
                Dim dblDenominator As Double: dblDenominator = ((5# - dVoltage_LOCAL) / 10000#)
                If dblDenominator = 0 Then dblDenominator = 0.000001
                dblDegrees = dVoltage_LOCAL / dblDenominator
                dblDegrees = (dblDegrees - 100#) / 0.388
                Print #hLogFile, Format$(dblDegrees, "##.00") & "    " & vbTab;
            Else
                If dVoltage(1, bIndexSub) < 0 Then
                    Print #hLogFile, Format$(str(Abs(dVoltage(1, bIndexSub))), "-#.000000  ") & vbTab;
                Else
                    Print #hLogFile, Format$(str(Abs(dVoltage(1, bIndexSub))), " #.000000  ") & vbTab;
                End If
            End If
        End If
    Next bIndexSub
    '#############
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
            If dVoltage(2, bIndexSub) < 0 Then
                Print #hLogFile, Format$(str(Abs(dVoltage(2, bIndexSub))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dVoltage(2, bIndexSub))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
            If dVoltage(3, bIndexSub) < 0 Then
                Print #hLogFile, Format$(str(Abs(dVoltage(3, bIndexSub))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dVoltage(3, bIndexSub))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
            If dVoltage(4, bIndexSub) < 0 Then
                Print #hLogFile, Format$(str(Abs(dVoltage(4, bIndexSub))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dVoltage(4, bIndexSub))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
            If dVoltage(5, bIndexSub) < 0 Then
                Print #hLogFile, Format$(str(Abs(dVoltage(5, bIndexSub))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dVoltage(5, bIndexSub))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    '9-27-13c
    If frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal" Then
    
        'uses the following which are set in graphic screen
        'Public dblCalOffsetVal_ForLogFile As Double
        'Public dblCalFullScaleVal_ForLogFile As Double
            
        If dblCalFullScaleVal_ForLogFile < 0 Then
            'Print #hLogFile, vbTab & vbTab & Format$(str(Abs(dblCalFullScaleVal_ForLogFile)), "-#.000000  ") & vbTab;
            Print #hLogFile, Format$(str(Abs(dblCalFullScaleVal_ForLogFile)), "-#.000000  ") & vbTab;
        Else
            'Print #hLogFile, vbTab & vbTab & Format$(str(Abs(dblCalFullScaleVal_ForLogFile)), " #.000000  ") & vbTab;
            Print #hLogFile, Format$(str(Abs(dblCalFullScaleVal_ForLogFile)), " #.000000  ") & vbTab;
        End If
    
        If dblCalOffsetVal_ForLogFile < 0 Then
            Print #hLogFile, Format$(str(Abs(dblCalOffsetVal_ForLogFile)), "-#.000000  ") & vbTab;
        Else
            Print #hLogFile, Format$(str(Abs(dblCalOffsetVal_ForLogFile)), " #.000000  ") & vbTab;
        End If
    End If
    
    
    
    If strScanLogfileComment <> "" Then
        Print #hLogFile, strScanLogfileComment;
        strScanLogfileComment = ""
    End If
    
    
    
    Print #hLogFile, ""

End Function
