Attribute VB_Name = "modOffsetVolts"
Option Explicit
'1-20-14 new function to copy CHoffset.ini to windows folder the first time that app is run
Public Function copyCHoffsetsToWinFolder()
    Dim strFolder As String
    Dim lngResult As Long
    On Error GoTo EXIT_ERR
    strFolder = String(MAX_PATH, 0)
    lngResult = GetWindowsDirectory(strFolder, MAX_PATH)
    If lngResult <> 0 Then
'        Dim myStr As String
'        myStr = Left$(strFolder, InStr(strFolder, vbNullChar) - 1) & "\CHoffset.ini"
'        FileCopy "CHoffset.ini", myStr
        
        Shell ("CopyIni.bat")
        copyCHoffsetsToWinFolder = True
    Else
        copyCHoffsetsToWinFolder = False
    End If
    Exit Function
    
EXIT_ERR:
    MsgBox vbCrLf & "Could not copy CHOffset.ini to Windows folder." _
        & vbCrLf & vbCrLf & "CHOffset.ini should be in current application folder but doesn't seem to be.  " _
        & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
    copyCHoffsetsToWinFolder = False
End Function

Public Function CheckIniExist_CHoffsets() As Boolean
    'do a fake read of the ini without any alternate parameters set to see if it exists
    Dim lRetVal_LOCAL As Long, strIniString As String: strIniString = String(32, vbNullChar)
    On Error GoTo EXIT_ERR
    lRetVal_LOCAL = GetPrivateProfileString("CHAN0", "1", "", strIniString, 8, "CHoffset.ini")
    If lRetVal_LOCAL = 0 Then
    
        '1-20-14 new code start ##############
        ' copy ini file that ships with app to windows folder the first time it's run
        Dim copySuccess As Boolean
        If copyCHoffsetsToWinFolder() = False Then
            MsgBox vbCrLf & "Could not copy CHOffset.ini to Windows folder." _
                & vbCrLf & vbCrLf & "CHOffset.ini should be in current application folder." _
                & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
            CheckIniExist_CHoffsets = False: GoTo EXIT1
        End If
        '1-20-14 new code end ##############
        
    End If
    CheckIniExist_CHoffsets = True: GoTo EXIT1
EXIT_ERR:
     CheckIniExist_CHoffsets = False
EXIT1:
    On Error GoTo 0

End Function
Public Function ReadIniFileSpecs_CHoffsets() As Boolean
    Dim lRetVal_LOCAL As Long
    Dim bIndex As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then
        bMainChan = bMainChan + 1
    End If
    
    
    Dim dblVoltsTemp As Double
    Dim fAllOffsetsAreZero_TOM As Boolean: fAllOffsetsAreZero_TOM = True
    
    If CheckIniExist_CHoffsets = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN0", subChStr, "", strIniString, 9, "CHoffset.ini")
        'dblCh0_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(0, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(0, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN1", subChStr, "", strIniString, 8, "CHoffset.ini")
        'dblCh1_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(1, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(1, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN2", subChStr, "", strIniString, 8, "CHoffset.ini")
        'dblCh2_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(2, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(2, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN3", subChStr, "", strIniString, 8, "CHoffset.ini")
        'dblCh3_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(3, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(3, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN4", subChStr, "", strIniString, 8, "CHoffset.ini")
        'dblCh4_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(4, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(4, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    For bIndex = 0 To 15
        subChStr = bIndex
        lRetVal_LOCAL = GetPrivateProfileString("CHAN5", subChStr, "", strIniString, 8, "CHoffset.ini")
        'dblCh5_offset(bIndex) = CDbl(strIniString)
        dblOffsetVoltages(5, bIndex) = CDbl(strIniString)
        If dblOffsetVoltages(5, bIndex) <> 0# Then fAllOffsetsAreZero_TOM = False
    Next bIndex
    
    Dim fRetVal As Boolean
    
    
    'TIM NOTE: Changed to following on 3-29-04 when Tom said that if all entries in the offset file
    ' are zero, then uncheck the use offset checkbox
    If fAllOffsetsAreZero_TOM = True Then
        '9-24-13 frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
'        bConfigChanges(CONFIG_MISC_USE_OFFSET_VOLTS) = 0
        bUseOffsetVoltages = 0
    Else
        '9-24-13 frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage"
        bUseOffsetVoltages = True
    End If
    
    ReadIniFileSpecs_CHoffsets = True
    GoTo EXIT1
     
EXIT_ERR:
    MsgBox vbCrLf & "Failed to read  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    ReadIniFileSpecs_CHoffsets = False
EXIT1:
    On Error GoTo 0
End Function

'Public Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" _
    (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Public Function WriteIniFileSpecs_CHoffsets_CurChan() As Boolean
    Dim lRetVal_LOCAL As Long
    Dim bIndex As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then bMainChan = bMainChan - 1
    
    Dim dblVoltsTemp As Double
    If CheckIniExist_CHoffsets = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    Dim strChOffsetVoltage As String
    
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(0, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN0", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
'    If fIsEMFapp Then
'        WriteIniFileSpecs_CHoffsets_CurChan = True
'        Exit Function
'    End If
    
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(1, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN1", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(2, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN2", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(3, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN3", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(4, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN4", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = Format$(str(dblOffsetVoltages(5, bIndex)), "##.000000")
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN5", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
    WriteIniFileSpecs_CHoffsets_CurChan = True
    GoTo EXIT1
     
EXIT_ERR:
    MsgBox vbCrLf & "Failed to write  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    WriteIniFileSpecs_CHoffsets_CurChan = False
EXIT1:
    On Error GoTo 0
End Function
Public Function WriteIniFileSpecs_CHoffsets_SetAllZero_TOM() As Boolean
'TIM NOTE: Tom wanted this 3-29-04
'He said he wanted to zero every channel in the entire offset file
' whenever the zero offset button was pressed, and then afterwards
' to uncheck the "use offset" checkbox

    Dim lRetVal_LOCAL As Long
    Dim bIndex, bIndex2 As Byte
    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bMainChan As Byte
    bMainChan = frmGraph.comboMainChan.Text
    If fIsEMFapp Then bMainChan = bMainChan - 1
    Dim dblVoltsTemp As Double
    If CheckIniExist_CHoffsets = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    Dim strChOffsetVoltage As String
    
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN0", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN1", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN2", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN3", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN4", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    For bIndex = 0 To 15
        strChOffsetVoltage = 0
        subChStr = bIndex
        lRetVal_LOCAL = WritePrivateProfileString("CHAN5", subChStr, strChOffsetVoltage, "CHoffset.ini")
    Next bIndex
    
    For bIndex = 0 To 5
        For bIndex2 = 0 To 15
            dblOffsetVoltages(bIndex, bIndex2) = 0#
        Next bIndex2
    Next bIndex
    
    'TIM NOTE: The following is to support Tom's request to set all offsets
    '  (main and sub chans) to zero if user presses the "zero offset" button
    
    '9-24-13 If frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage" Then
    '9-24-13     frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
        'bConfigChanges(CONFIG_MISC_USE_OFFSET_VOLTS) = 0
    '9-24-13     bUseOffsetVoltages = 0
    '9-24-13 End If
    
    WriteIniFileSpecs_CHoffsets_SetAllZero_TOM = True
    GoTo EXIT1
     
EXIT_ERR:
    MsgBox vbCrLf & "Failed to write  CHOffset.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    WriteIniFileSpecs_CHoffsets_SetAllZero_TOM = False
EXIT1:
    On Error GoTo 0
End Function


